using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;
using System.Security;
using Decal.Interop.Core;
using Decal.Interop.Inject;

namespace Decal.Interop.Render;

[ComImport]
[TypeLibType(2)]
[ClassInterface(ClassInterfaceType.None)]
[ComSourceInterfaces("Decal.Interop.Render.IRenderServiceEvents\0\0")]
[Guid("FB3C8286-88ED-4B4D-B413-94B40F346239")]
[SuppressUnmanagedCodeSecurity]
public class RenderServiceClass : IRenderService, RenderService, IRenderServiceEvents_Event
{
	[DispId(1610743808)]
	public virtual extern object Device
	{
		[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
		[DispId(1610743808)]
		[return: MarshalAs(UnmanagedType.IUnknown)]
		get;
	}

	public virtual extern event IRenderServiceEvents_DeviceLostEventHandler DeviceLost;

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	[DispId(1610743809)]
	[return: MarshalAs(UnmanagedType.Interface)]
	public virtual extern HUDView CreateHUD([In] ref tagRECT pRegion);

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	[DispId(1610743810)]
	[return: MarshalAs(UnmanagedType.Interface)]
	public virtual extern HUDBackground CreateBackground([In] ref tagRECT pRegion);

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	[DispId(1610743811)]
	[return: MarshalAs(UnmanagedType.Interface)]
	public virtual extern HUDView EncapsulateHUD([In] ref tagPOINT Coords, [MarshalAs(UnmanagedType.IUnknown)] object pSurface);

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	[DispId(1610743812)]
	[return: MarshalAs(UnmanagedType.Interface)]
	public virtual extern HUDBackground EncapsulateBackground([In] ref tagPOINT Coords, [MarshalAs(UnmanagedType.IUnknown)] object pSurface);

	[MethodImpl(MethodImplOptions.InternalCall, MethodCodeType = MethodCodeType.Runtime)]
	[DispId(1610743813)]
	public virtual extern void RemoveHUD([In][MarshalAs(UnmanagedType.Interface)] HUDView pHUD);
}
